Index: trunk/l10n/tspsg_en.ts
===================================================================
--- trunk/l10n/tspsg_en.ts	(revision 98)
+++ trunk/l10n/tspsg_en.ts	(revision 100)
@@ -6,5 +6,11 @@
     <name>--------</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="616"/>
+        <location filename="../src/mainwindow.cpp" line="411"/>
+        <source>TRANSLATION</source>
+        <comment>Please, provide translator credits here.</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="727"/>
         <source>LANGNAME</source>
         <comment>Please, provide a native name of your translation language here.</comment>
@@ -25,41 +31,41 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="365"/>
+        <location filename="../src/tspmodel.cpp" line="377"/>
         <source>Unexpected end of file.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="367"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="369"/>
+        <location filename="../src/tspmodel.cpp" line="381"/>
         <source>Unknown error.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Task Load</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unable to load task:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -67,11 +73,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -79,6 +85,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -86,17 +92,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Task Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
         <source>Unable to create task file.
 Error: %1
@@ -105,11 +111,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -120,33 +126,7 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="91"/>
-        <source>%v of %m parts found</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="95"/>
-        <source>Calculating optimal route...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="96"/>
-        <source>Solution Progress</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Solution Result</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Unable to find solution.
-Maybe, this task has no solutions.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="42"/>
-        <location filename="../src/tspsolver.cpp" line="44"/>
-        <location filename="../src/tspsolver.cpp" line="47"/>
+        <location filename="../src/tspsolver.cpp" line="75"/>
+        <location filename="../src/tspsolver.cpp" line="77"/>
+        <location filename="../src/tspsolver.cpp" line="80"/>
         <source>City %1</source>
         <translation type="unfinished"></translation>
@@ -156,77 +136,98 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
-        <source>Would you like to save changes in current task?</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ui" line="15"/>
-        <location filename="../src/mainwindow.cpp" line="801"/>
+        <location filename="../src/mainwindow.cpp" line="923"/>
         <source>Travelling Salesman Problem</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Language Change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
+        <location filename="../src/mainwindow.cpp" line="804"/>
         <source>Unsaved Changes</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="131"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
         <source>All Supported Formats</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="132"/>
-        <location filename="../src/mainwindow.cpp" line="133"/>
+        <location filename="../src/mainwindow.cpp" line="135"/>
+        <location filename="../src/mainwindow.cpp" line="136"/>
         <source>%1 Task Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="134"/>
-        <location filename="../src/mainwindow.cpp" line="191"/>
-        <location filename="../src/mainwindow.cpp" line="778"/>
+        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <location filename="../src/mainwindow.cpp" line="900"/>
         <source>All Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="185"/>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>PDF Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="187"/>
+        <location filename="../src/mainwindow.cpp" line="197"/>
         <source>HTML Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
+        <location filename="../src/mainwindow.cpp" line="199"/>
         <source>OpenDocument Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <source>You have changed color settings.
+They will be applied to the next solution output.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="338"/>
+        <source>Version</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="487"/>
+        <source>%v of %1 parts found</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="510"/>
+        <source>Generating solution output...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="522"/>
+        <source>Generating step %v</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="536"/>
         <source>Selected candidate for branching: %1.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
-        <location filename="../src/mainwindow.cpp" line="445"/>
+        <location filename="../src/mainwindow.cpp" line="536"/>
+        <location filename="../src/mainwindow.cpp" line="543"/>
         <source>(%1;%2)</source>
         <translation type="unfinished"></translation>
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="447"/>
+        <location filename="../src/mainwindow.cpp" line="545"/>
         <source>%n alternate candidate(s) for branching: %1.</source>
         <translation>
@@ -235,6 +236,11 @@
         </translation>
     </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="557"/>
+        <source>Generating footer</source>
+        <translation type="unfinished"></translation>
+    </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="465"/>
+        <location filename="../src/mainwindow.cpp" line="566"/>
         <source>The price is &lt;b&gt;%n&lt;/b&gt; unit(s).</source>
         <translation>
@@ -244,83 +250,197 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="777"/>
+        <location filename="../src/mainwindow.cpp" line="580"/>
+        <source>Cleaning up...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="804"/>
+        <source>Would you like to save changes in the current task?</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="890"/>
+        <location filename="../src/mainwindow.cpp" line="893"/>
+        <source>Check for %1 updates</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="899"/>
         <source>%1 Task File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <location filename="../src/mainwindow.cpp" line="312"/>
         <source>Settings Changed</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="141"/>
         <source>Task Load</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
-        <source>You have changed color settings.
-Do you wish to apply them to current solution text?</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="370"/>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Solution Save</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Unable to save the solution.
+Error: %1</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="312"/>
+        <source>You have changed the application language.
+To get current solution output in the new language
+you need to re-run the solution process.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Unsupported Feature</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Sorry, but this feature is not supported on your platform
+or support for this feature was not installed.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="347"/>
+        <source>Target OS (ARCH)</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>Qt library</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <source>shared</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="350"/>
+        <source>Build time</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="351"/>
+        <source>Runtime</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>static</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="355"/>
+        <source>Buid &lt;b&gt;%1&lt;/b&gt;, built on &lt;b&gt;%2&lt;/b&gt; at &lt;b&gt;%3&lt;/b&gt;</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="356"/>
+        <source>Algorithm</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="358"/>
+        <source>TSPSG is free software: you can redistribute it and/or modify it&lt;br&gt;under the terms of the GNU General Public License as published&lt;br&gt;by the Free Software Foundation, either version 3 of the License,&lt;br&gt;or (at your option) any later version.&lt;br&gt;&lt;br&gt;TSPSG is distributed in the hope that it will be useful, but&lt;br&gt;WITHOUT ANY WARRANTY; without even the implied warranty of&lt;br&gt;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the&lt;br&gt;GNU General Public License for more details.&lt;br&gt;&lt;br&gt;You should have received a copy of the GNU General Public License&lt;br&gt;along with TSPSG.  If not, see &lt;a href=&quot;http://www.gnu.org/licenses/&quot;&gt;http://www.gnu.org/licenses/&lt;/a&gt;.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="435"/>
         <source>About TSPSG</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Data error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="424"/>
+        <location filename="../src/mainwindow.cpp" line="491"/>
+        <source>Calculating optimal route...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="492"/>
+        <source>Solution Progress</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Solution Result</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Unable to find a solution.
+Maybe, this task has no solution.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="509"/>
+        <source>Generating header</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="516"/>
         <source>Variant #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="425"/>
+        <location filename="../src/mainwindow.cpp" line="517"/>
         <source>Task:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="428"/>
-        <location filename="../src/mainwindow.cpp" line="475"/>
+        <location filename="../src/mainwindow.cpp" line="515"/>
+        <location filename="../src/mainwindow.cpp" line="519"/>
         <source>Solution of Variant #%1 task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="434"/>
+        <location filename="../src/mainwindow.cpp" line="532"/>
         <source>Step #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="460"/>
+        <location filename="../src/mainwindow.cpp" line="561"/>
         <source>Optimal path:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="462"/>
+        <location filename="../src/mainwindow.cpp" line="563"/>
         <source>Resulting path:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="467"/>
+        <location filename="../src/mainwindow.cpp" line="568"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="470"/>
+        <location filename="../src/mainwindow.cpp" line="571"/>
         <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Unable to load the translation language.
 Falling back to autodetection.</source>
@@ -328,20 +448,25 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="754"/>
+        <location filename="../src/mainwindow.cpp" line="867"/>
         <source>Set application language to %1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="786"/>
+        <location filename="../src/mainwindow.cpp" line="888"/>
+        <source>Check for &amp;Updates...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="908"/>
         <source>Task Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <source>Language will be autodetected on next application start.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <source>Language will be autodetected on the next application start.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -350,9 +475,8 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="151"/>
-        <location filename="../src/mainwindow.cpp" line="152"/>
-        <location filename="../src/mainwindow.cpp" line="168"/>
-        <location filename="../src/mainwindow.cpp" line="290"/>
-        <location filename="../src/mainwindow.h" line="107"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="179"/>
+        <location filename="../src/mainwindow.cpp" line="297"/>
+        <location filename="../src/mainwindow.h" line="113"/>
         <source>Untitled</source>
         <translation type="unfinished"></translation>
@@ -627,10 +751,10 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="765"/>
+        <location filename="../src/mainwindow.cpp" line="878"/>
         <source>&amp;Print...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="772"/>
+        <location filename="../src/mainwindow.cpp" line="885"/>
         <source>Ctrl+P</source>
         <translation type="unfinished"></translation>
@@ -652,25 +776,25 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="757"/>
+        <location filename="../src/mainwindow.cpp" line="870"/>
         <source>P&amp;rint Preview...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="759"/>
+        <location filename="../src/mainwindow.cpp" line="872"/>
         <source>Preview solution results</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="762"/>
+        <location filename="../src/mainwindow.cpp" line="875"/>
         <source>Preview current solution results before printing</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="767"/>
+        <location filename="../src/mainwindow.cpp" line="880"/>
         <source>Print solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="770"/>
+        <location filename="../src/mainwindow.cpp" line="883"/>
         <source>Print current solution results</source>
         <translation type="unfinished"></translation>
Index: trunk/l10n/tspsg_ru.ts
===================================================================
--- trunk/l10n/tspsg_ru.ts	(revision 98)
+++ trunk/l10n/tspsg_ru.ts	(revision 100)
@@ -6,14 +6,15 @@
     <name>--------</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="616"/>
+        <location filename="../src/mainwindow.cpp" line="411"/>
+        <source>TRANSLATION</source>
+        <comment>Please, provide translator credits here.</comment>
+        <translation>Русский перевод:&lt;br&gt;&lt;a href=&quot;http://oleksii.name/&quot;&gt;Алексей &quot;Lёppa&quot; Сердюк&lt;/a&gt;</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="727"/>
         <source>LANGNAME</source>
         <comment>Please, provide a native name of your translation language here.</comment>
         <translation>Русский</translation>
     </message>
-    <message>
-        <source>TRANSLATION</source>
-        <comment>Please, provide translator credits here.</comment>
-        <translation>Русский перевод:&lt;br&gt;&lt;a href=&quot;http://oleksii.name/&quot;&gt;Алексей Lёppa Сердюк&lt;/a&gt;</translation>
-    </message>
 </context>
 <context>
@@ -30,10 +31,10 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="365"/>
+        <location filename="../src/tspmodel.cpp" line="377"/>
         <source>Unexpected end of file.</source>
         <translation>Неожиданный конец файла.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="367"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation>Прочитаны испорченные данные.
@@ -41,31 +42,31 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="369"/>
+        <location filename="../src/tspmodel.cpp" line="381"/>
         <source>Unknown error.</source>
         <translation>Неизвестная ошибка.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Task Load</source>
         <translation>Загрузка условия</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unable to load task:</source>
         <translation>Невозможно загрузить условие:</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -74,11 +75,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation>Неизвестный формат файла или файл поврежден.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -87,6 +88,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -95,17 +96,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Task Save</source>
         <translation>Сохранение условия</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
         <source>Unable to create task file.
 Error: %1
@@ -116,11 +117,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -132,34 +133,7 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="91"/>
-        <source>%v of %m parts found</source>
-        <translation>Найдено %v з %m переходов</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="95"/>
-        <source>Calculating optimal route...</source>
-        <translation>Расчет оптимального пути...</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="96"/>
-        <source>Solution Progress</source>
-        <translation>Состояние решения</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Solution Result</source>
-        <translation>Результат решения</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Unable to find solution.
-Maybe, this task has no solutions.</source>
-        <translation>Не удалось найти решение.
-Возможно, у задачи нет решения.</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="42"/>
-        <location filename="../src/tspsolver.cpp" line="44"/>
-        <location filename="../src/tspsolver.cpp" line="47"/>
+        <location filename="../src/tspsolver.cpp" line="75"/>
+        <location filename="../src/tspsolver.cpp" line="77"/>
+        <location filename="../src/tspsolver.cpp" line="80"/>
         <source>City %1</source>
         <translation>Город %1</translation>
@@ -169,6 +143,6 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>Language change</source>
         <translation>Смена языка</translation>
@@ -176,70 +150,65 @@
     <message>
         <location filename="../ui/mainwindow.ui" line="15"/>
-        <location filename="../src/mainwindow.cpp" line="801"/>
+        <location filename="../src/mainwindow.cpp" line="923"/>
         <source>Travelling Salesman Problem</source>
         <translation>Задача коммивояжера</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
+        <location filename="../src/mainwindow.cpp" line="804"/>
         <source>Unsaved Changes</source>
         <translation>Несохраненные изменения</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="131"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
         <source>All Supported Formats</source>
         <translation>Все поддерживаемые форматы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="134"/>
-        <location filename="../src/mainwindow.cpp" line="191"/>
-        <location filename="../src/mainwindow.cpp" line="778"/>
+        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <location filename="../src/mainwindow.cpp" line="900"/>
         <source>All Files</source>
         <translation>Все файлы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="132"/>
-        <location filename="../src/mainwindow.cpp" line="133"/>
+        <location filename="../src/mainwindow.cpp" line="135"/>
+        <location filename="../src/mainwindow.cpp" line="136"/>
         <source>%1 Task Files</source>
         <translation>Файлы условий %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Language Change</source>
         <translation>Смена языка</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
-        <source>Would you like to save changes in current task?</source>
-        <translation>Желаете сохранить изменения в текущей задаче?</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="185"/>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>PDF Files</source>
         <translation>Файли PDF</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="187"/>
+        <location filename="../src/mainwindow.cpp" line="197"/>
         <source>HTML Files</source>
         <translation>Файлы HTML</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
+        <location filename="../src/mainwindow.cpp" line="199"/>
         <source>OpenDocument Files</source>
         <translation>Файлы OpenDocument</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
+        <location filename="../src/mainwindow.cpp" line="536"/>
         <source>Selected candidate for branching: %1.</source>
         <translation>Выбранный кандидат для ветвления: %1.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
-        <location filename="../src/mainwindow.cpp" line="445"/>
+        <location filename="../src/mainwindow.cpp" line="536"/>
+        <location filename="../src/mainwindow.cpp" line="543"/>
         <source>(%1;%2)</source>
         <translation></translation>
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="447"/>
+        <location filename="../src/mainwindow.cpp" line="545"/>
         <source>%n alternate candidate(s) for branching: %1.</source>
         <translation>
@@ -250,5 +219,5 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="465"/>
+        <location filename="../src/mainwindow.cpp" line="566"/>
         <source>The price is &lt;b&gt;%n&lt;/b&gt; unit(s).</source>
         <translation>
@@ -259,84 +228,228 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="777"/>
+        <location filename="../src/mainwindow.cpp" line="890"/>
+        <location filename="../src/mainwindow.cpp" line="893"/>
+        <source>Check for %1 updates</source>
+        <translation>Проверить обновления %1</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="899"/>
         <source>%1 Task File</source>
         <translation>Файл условия %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <location filename="../src/mainwindow.cpp" line="312"/>
         <source>Settings Changed</source>
         <translation>Параметры изменены</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="141"/>
         <source>Task Load</source>
         <translation>Загрузка условия</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
-        <source>You have changed color settings.
-Do you wish to apply them to current solution text?</source>
-        <translation>Вы изменили параметры цвета.
-Желаете применить их к текущему тексту решения?</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="370"/>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Unsupported Feature</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Sorry, but this feature is not supported on your platform
+or support for this feature was not installed.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="338"/>
+        <source>Version</source>
+        <translation>Версия</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="347"/>
+        <source>Target OS (ARCH)</source>
+        <translation>Целевая ОС (архитектура)</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>Qt library</source>
+        <translation>Библиотека Qt</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <source>shared</source>
+        <translation>динамическая</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="350"/>
+        <source>Build time</source>
+        <translation>Времени сборки</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="351"/>
+        <source>Runtime</source>
+        <translation>Времени исполнения</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>static</source>
+        <translation>статическая</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="355"/>
+        <source>Buid &lt;b&gt;%1&lt;/b&gt;, built on &lt;b&gt;%2&lt;/b&gt; at &lt;b&gt;%3&lt;/b&gt;</source>
+        <translation>Сборка &lt;b&gt;%1&lt;/b&gt;, собрана &lt;b&gt;%2&lt;/b&gt; в &lt;b&gt;%3&lt;/b&gt;</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="356"/>
+        <source>Algorithm</source>
+        <translation>Алгоритм</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="358"/>
+        <source>TSPSG is free software: you can redistribute it and/or modify it&lt;br&gt;under the terms of the GNU General Public License as published&lt;br&gt;by the Free Software Foundation, either version 3 of the License,&lt;br&gt;or (at your option) any later version.&lt;br&gt;&lt;br&gt;TSPSG is distributed in the hope that it will be useful, but&lt;br&gt;WITHOUT ANY WARRANTY; without even the implied warranty of&lt;br&gt;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the&lt;br&gt;GNU General Public License for more details.&lt;br&gt;&lt;br&gt;You should have received a copy of the GNU General Public License&lt;br&gt;along with TSPSG.  If not, see &lt;a href=&quot;http://www.gnu.org/licenses/&quot;&gt;http://www.gnu.org/licenses/&lt;/a&gt;.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="435"/>
         <source>About TSPSG</source>
         <translation>Про TSPSG</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Data error</source>
         <translation>Ошибка в данных</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="424"/>
+        <location filename="../src/mainwindow.cpp" line="491"/>
+        <source>Calculating optimal route...</source>
+        <translation>Расчет оптимального пути...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="492"/>
+        <source>Solution Progress</source>
+        <translation>Состояние решения</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Solution Result</source>
+        <translation>Результат решения</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Unable to find a solution.
+Maybe, this task has no solution.</source>
+        <translation>Не удалось найти решение.
+Возможно, у задачи нет решения.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="509"/>
+        <source>Generating header</source>
+        <translation>Генерация заголовка</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="516"/>
         <source>Variant #%1</source>
         <translation>Вариант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="425"/>
+        <location filename="../src/mainwindow.cpp" line="517"/>
         <source>Task:</source>
         <translation>Условие:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="428"/>
-        <location filename="../src/mainwindow.cpp" line="475"/>
+        <location filename="../src/mainwindow.cpp" line="515"/>
+        <location filename="../src/mainwindow.cpp" line="519"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Решение варианта №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="434"/>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Solution Save</source>
+        <translation>Сохранение решения</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Unable to save the solution.
+Error: %1</source>
+        <translation>Невозможно сохранить решение.
+Ошибка: %1</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <source>You have changed color settings.
+They will be applied to the next solution output.</source>
+        <translation>Вы изменили параметры цвета.
+Они будут применены к следующему тексту решения.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="312"/>
+        <source>You have changed the application language.
+To get current solution output in the new language
+you need to re-run the solution process.</source>
+        <translation>Вы изменили язык приложения.
+Чтобы получить текст текущего решения на новом
+языке, необходимо выполнить решение заново.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="487"/>
+        <source>%v of %1 parts found</source>
+        <translation>Найдено %v з %1 переходов</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="510"/>
+        <source>Generating solution output...</source>
+        <translation>Генерация текста решения...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="522"/>
+        <source>Generating step %v</source>
+        <translation>Генерация шага %v</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="532"/>
         <source>Step #%1</source>
         <translation>Шаг №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="460"/>
+        <location filename="../src/mainwindow.cpp" line="557"/>
+        <source>Generating footer</source>
+        <translation>Генерация окончания</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="561"/>
         <source>Optimal path:</source>
         <translation>Оптимальный путь:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="462"/>
+        <location filename="../src/mainwindow.cpp" line="563"/>
         <source>Resulting path:</source>
         <translation>Найденный путь:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="467"/>
+        <location filename="../src/mainwindow.cpp" line="568"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Стоимость - &lt;b&gt;%1&lt;/b&gt; единиц.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="470"/>
+        <location filename="../src/mainwindow.cpp" line="571"/>
         <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
         <translation>&lt;b&gt;ВНИМАНИЕ!!!&lt;/b&gt;&lt;br&gt;Найденное решение является рекордом, но может оказаться не оптимальным.&lt;br&gt;Для получения оптимального решения, или проверки текущего на оптимальность, требуется продолжить итерации.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <location filename="../src/mainwindow.cpp" line="580"/>
+        <source>Cleaning up...</source>
+        <translation>Очистка...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Unable to load the translation language.
 Falling back to autodetection.</source>
@@ -345,20 +458,30 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="754"/>
+        <location filename="../src/mainwindow.cpp" line="804"/>
+        <source>Would you like to save changes in the current task?</source>
+        <translation>Желаете сохранить изменения в текущей задаче?</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="867"/>
         <source>Set application language to %1</source>
         <translation>Изменить язык приложения на %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="786"/>
+        <location filename="../src/mainwindow.cpp" line="888"/>
+        <source>Check for &amp;Updates...</source>
+        <translation>Проверить &amp;обновления...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="908"/>
         <source>Task Save</source>
         <translation>Сохранение условия</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <source>Language will be autodetected on next application start.</source>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <source>Language will be autodetected on the next application start.</source>
         <translation>Язык будет автоматически определен при следующем запуске приложения.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -369,9 +492,8 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="151"/>
-        <location filename="../src/mainwindow.cpp" line="152"/>
-        <location filename="../src/mainwindow.cpp" line="168"/>
-        <location filename="../src/mainwindow.cpp" line="290"/>
-        <location filename="../src/mainwindow.h" line="107"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="179"/>
+        <location filename="../src/mainwindow.cpp" line="297"/>
+        <location filename="../src/mainwindow.h" line="113"/>
         <source>Untitled</source>
         <translation>Без имени</translation>
@@ -651,35 +773,35 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="757"/>
+        <location filename="../src/mainwindow.cpp" line="870"/>
         <source>P&amp;rint Preview...</source>
         <translation>П&amp;редварительный просмотр...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="759"/>
+        <location filename="../src/mainwindow.cpp" line="872"/>
         <source>Preview solution results</source>
         <translation>Предварительный просмотр результатов решения</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="762"/>
+        <location filename="../src/mainwindow.cpp" line="875"/>
         <source>Preview current solution results before printing</source>
         <translation>Предварительный просмотр результатов решения перед печатью</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="765"/>
+        <location filename="../src/mainwindow.cpp" line="878"/>
         <source>&amp;Print...</source>
         <translation>&amp;Печать...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="767"/>
+        <location filename="../src/mainwindow.cpp" line="880"/>
         <source>Print solution</source>
         <translation>Печать решения</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="770"/>
+        <location filename="../src/mainwindow.cpp" line="883"/>
         <source>Print current solution results</source>
         <translation>Распечатать текущие результаты решения</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="772"/>
+        <location filename="../src/mainwindow.cpp" line="885"/>
         <source>Ctrl+P</source>
         <translation></translation>
@@ -791,5 +913,5 @@
         <location filename="../ui/settingsdialog.ui" line="361"/>
         <source>Solution output settings</source>
-        <translation>Настройки вывода решения</translation>
+        <translation>Настройки текста решения</translation>
     </message>
     <message>
Index: trunk/l10n/tspsg_uk.ts
===================================================================
--- trunk/l10n/tspsg_uk.ts	(revision 98)
+++ trunk/l10n/tspsg_uk.ts	(revision 100)
@@ -6,14 +6,15 @@
     <name>--------</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="616"/>
+        <location filename="../src/mainwindow.cpp" line="411"/>
+        <source>TRANSLATION</source>
+        <comment>Please, provide translator credits here.</comment>
+        <translation>Український переклад:&lt;br&gt;&lt;a href=&quot;http://oleksii.name/&quot;&gt;Олексій &quot;Lёppa&quot; Сердюк&lt;/a&gt;</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="727"/>
         <source>LANGNAME</source>
         <comment>Please, provide a native name of your translation language here.</comment>
         <translation>Українська</translation>
     </message>
-    <message>
-        <source>TRANSLATION</source>
-        <comment>Please, provide translator credits here.</comment>
-        <translation>Український переклад:&lt;br&gt;&lt;a href=&quot;http://oleksii.name/&quot;&gt;Олексій Lёppa Сердюк&lt;/a&gt;</translation>
-    </message>
 </context>
 <context>
@@ -30,10 +31,10 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="365"/>
+        <location filename="../src/tspmodel.cpp" line="377"/>
         <source>Unexpected end of file.</source>
         <translation>Неочікуваний кінець файлу.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="367"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation>Прочитано ушкоджені дані.
@@ -41,31 +42,31 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="369"/>
+        <location filename="../src/tspmodel.cpp" line="381"/>
         <source>Unknown error.</source>
         <translation>Невідома помилка.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
-        <location filename="../src/tspmodel.cpp" line="371"/>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
+        <location filename="../src/tspmodel.cpp" line="384"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unable to load task:</source>
         <translation>Неможливо завантажити умову:</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="141"/>
+        <location filename="../src/tspmodel.cpp" line="142"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -74,11 +75,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="168"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation>Невідомий формат файлу або файл пошкоджено.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="388"/>
-        <location filename="../src/tspmodel.cpp" line="440"/>
+        <location filename="../src/tspmodel.cpp" line="403"/>
+        <location filename="../src/tspmodel.cpp" line="459"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -87,6 +88,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="402"/>
-        <location filename="../src/tspmodel.cpp" line="450"/>
+        <location filename="../src/tspmodel.cpp" line="419"/>
+        <location filename="../src/tspmodel.cpp" line="471"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -95,17 +96,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="234"/>
+        <location filename="../src/tspmodel.cpp" line="238"/>
         <source>Unable to create task file.
 Error: %1
@@ -116,11 +117,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="242"/>
-        <location filename="../src/tspmodel.cpp" line="250"/>
-        <location filename="../src/tspmodel.cpp" line="258"/>
-        <location filename="../src/tspmodel.cpp" line="266"/>
-        <location filename="../src/tspmodel.cpp" line="274"/>
+        <location filename="../src/tspmodel.cpp" line="246"/>
+        <location filename="../src/tspmodel.cpp" line="255"/>
+        <location filename="../src/tspmodel.cpp" line="264"/>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="291"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -132,34 +133,7 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="91"/>
-        <source>%v of %m parts found</source>
-        <translation>Знайдено %v з %m переходів</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="95"/>
-        <source>Calculating optimal route...</source>
-        <translation>Обчислення оптимального шляху...</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="96"/>
-        <source>Solution Progress</source>
-        <translation>Поступ розв&apos;зку</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Solution Result</source>
-        <translation>Результат розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="172"/>
-        <source>Unable to find solution.
-Maybe, this task has no solutions.</source>
-        <translation>Не вдалося знайти розв&apos;язок.
-Можливо, у задачі немає розв&apos;зку.</translation>
-    </message>
-    <message>
-        <location filename="../src/tspsolver.cpp" line="42"/>
-        <location filename="../src/tspsolver.cpp" line="44"/>
-        <location filename="../src/tspsolver.cpp" line="47"/>
+        <location filename="../src/tspsolver.cpp" line="75"/>
+        <location filename="../src/tspsolver.cpp" line="77"/>
+        <location filename="../src/tspsolver.cpp" line="80"/>
         <source>City %1</source>
         <translation>Місто %1</translation>
@@ -199,35 +173,35 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="757"/>
+        <location filename="../src/mainwindow.cpp" line="870"/>
         <source>P&amp;rint Preview...</source>
         <translation>&amp;Попередній перегляд...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="759"/>
+        <location filename="../src/mainwindow.cpp" line="872"/>
         <source>Preview solution results</source>
         <translation>Попередній перегляд результатів розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="762"/>
+        <location filename="../src/mainwindow.cpp" line="875"/>
         <source>Preview current solution results before printing</source>
         <translation>Попередній перегляд результатів розв&apos;язку перед друком</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="765"/>
+        <location filename="../src/mainwindow.cpp" line="878"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="767"/>
+        <location filename="../src/mainwindow.cpp" line="880"/>
         <source>Print solution</source>
-        <translation>Друк розв&apos;зку</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="770"/>
+        <translation>Друк розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="883"/>
         <source>Print current solution results</source>
         <translation>Роздрукувати поточний результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="772"/>
+        <location filename="../src/mainwindow.cpp" line="885"/>
         <source>Ctrl+P</source>
         <translation></translation>
@@ -492,6 +466,6 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>Language change</source>
         <translation>Зміна мови</translation>
@@ -499,70 +473,65 @@
     <message>
         <location filename="../ui/mainwindow.ui" line="15"/>
-        <location filename="../src/mainwindow.cpp" line="801"/>
+        <location filename="../src/mainwindow.cpp" line="923"/>
         <source>Travelling Salesman Problem</source>
         <translation>Задача комівояжера</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
+        <location filename="../src/mainwindow.cpp" line="804"/>
         <source>Unsaved Changes</source>
         <translation>Незбережені зміни</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="131"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
         <source>All Supported Formats</source>
         <translation>Усі підтримувані формати</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="134"/>
-        <location filename="../src/mainwindow.cpp" line="191"/>
-        <location filename="../src/mainwindow.cpp" line="778"/>
+        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <location filename="../src/mainwindow.cpp" line="900"/>
         <source>All Files</source>
         <translation>Усі файли</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="132"/>
-        <location filename="../src/mainwindow.cpp" line="133"/>
+        <location filename="../src/mainwindow.cpp" line="135"/>
+        <location filename="../src/mainwindow.cpp" line="136"/>
         <source>%1 Task Files</source>
         <translation>Файли умов %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Language Change</source>
         <translation>Зміна мови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="693"/>
-        <source>Would you like to save changes in current task?</source>
-        <translation>Бажаете зберегти зміни у поточній задачі?</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="185"/>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>PDF Files</source>
         <translation>Файлы PDF</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="187"/>
+        <location filename="../src/mainwindow.cpp" line="197"/>
         <source>HTML Files</source>
         <translation>Файли HTML</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
+        <location filename="../src/mainwindow.cpp" line="199"/>
         <source>OpenDocument Files</source>
         <translation>Файли OpenDocument</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
+        <location filename="../src/mainwindow.cpp" line="536"/>
         <source>Selected candidate for branching: %1.</source>
         <translation>Обраний кандидат на розгалудження: %1.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="438"/>
-        <location filename="../src/mainwindow.cpp" line="445"/>
+        <location filename="../src/mainwindow.cpp" line="536"/>
+        <location filename="../src/mainwindow.cpp" line="543"/>
         <source>(%1;%2)</source>
         <translation></translation>
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="447"/>
+        <location filename="../src/mainwindow.cpp" line="545"/>
         <source>%n alternate candidate(s) for branching: %1.</source>
         <translation>
@@ -573,5 +542,5 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/mainwindow.cpp" line="465"/>
+        <location filename="../src/mainwindow.cpp" line="566"/>
         <source>The price is &lt;b&gt;%n&lt;/b&gt; unit(s).</source>
         <translation>
@@ -582,84 +551,228 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="777"/>
+        <location filename="../src/mainwindow.cpp" line="890"/>
+        <location filename="../src/mainwindow.cpp" line="893"/>
+        <source>Check for %1 updates</source>
+        <translation>Перевірити оновлення %1</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="899"/>
         <source>%1 Task File</source>
         <translation>Файл умови %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <location filename="../src/mainwindow.cpp" line="312"/>
         <source>Settings Changed</source>
         <translation>Параметри змінено</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="137"/>
+        <location filename="../src/mainwindow.cpp" line="141"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="260"/>
-        <source>You have changed color settings.
-Do you wish to apply them to current solution text?</source>
-        <translation>Ви змінили параметри кольору.
-Бажаєте застосувати їх до поточного тексту розв&apos;зку?</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="370"/>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Unsupported Feature</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="320"/>
+        <source>Sorry, but this feature is not supported on your platform
+or support for this feature was not installed.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="338"/>
+        <source>Version</source>
+        <translation>Версія</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="347"/>
+        <source>Target OS (ARCH)</source>
+        <translation>Цільова ОС (архітектура)</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>Qt library</source>
+        <translation>Бібліотека Qt</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="349"/>
+        <source>shared</source>
+        <translation>динамічна</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="350"/>
+        <source>Build time</source>
+        <translation>Часу збірки</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="351"/>
+        <source>Runtime</source>
+        <translation>Часу виконання</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="353"/>
+        <source>static</source>
+        <translation>статична</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="355"/>
+        <source>Buid &lt;b&gt;%1&lt;/b&gt;, built on &lt;b&gt;%2&lt;/b&gt; at &lt;b&gt;%3&lt;/b&gt;</source>
+        <translation>Збірка &lt;b&gt;%1&lt;/b&gt;, зібрана &lt;b&gt;%2&lt;/b&gt; о &lt;b&gt;%3&lt;/b&gt;</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="356"/>
+        <source>Algorithm</source>
+        <translation>Алгоритм</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="358"/>
+        <source>TSPSG is free software: you can redistribute it and/or modify it&lt;br&gt;under the terms of the GNU General Public License as published&lt;br&gt;by the Free Software Foundation, either version 3 of the License,&lt;br&gt;or (at your option) any later version.&lt;br&gt;&lt;br&gt;TSPSG is distributed in the hope that it will be useful, but&lt;br&gt;WITHOUT ANY WARRANTY; without even the implied warranty of&lt;br&gt;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the&lt;br&gt;GNU General Public License for more details.&lt;br&gt;&lt;br&gt;You should have received a copy of the GNU General Public License&lt;br&gt;along with TSPSG.  If not, see &lt;a href=&quot;http://www.gnu.org/licenses/&quot;&gt;http://www.gnu.org/licenses/&lt;/a&gt;.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="435"/>
         <source>About TSPSG</source>
         <translation>Про TSPSG</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Data error</source>
         <translation>Помилка у даних</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="411"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="424"/>
+        <location filename="../src/mainwindow.cpp" line="491"/>
+        <source>Calculating optimal route...</source>
+        <translation>Обчислення оптимального шляху...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="492"/>
+        <source>Solution Progress</source>
+        <translation>Поступ розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Solution Result</source>
+        <translation>Результат розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="506"/>
+        <source>Unable to find a solution.
+Maybe, this task has no solution.</source>
+        <translation>Не вдалося знайти розв&apos;язок.
+Можливо, у задачі немає розв&apos;язку.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="509"/>
+        <source>Generating header</source>
+        <translation>Генерація заголовку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="516"/>
         <source>Variant #%1</source>
         <translation>Варіант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="425"/>
+        <location filename="../src/mainwindow.cpp" line="517"/>
         <source>Task:</source>
         <translation>Умова:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="428"/>
-        <location filename="../src/mainwindow.cpp" line="475"/>
+        <location filename="../src/mainwindow.cpp" line="515"/>
+        <location filename="../src/mainwindow.cpp" line="519"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Розв&apos;язок варіанту №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="434"/>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Solution Save</source>
+        <translation>Збереження розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="230"/>
+        <source>Unable to save the solution.
+Error: %1</source>
+        <translation>Неможливо зберегти розв&apos;язок.
+Помилка: %1</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="272"/>
+        <source>You have changed color settings.
+They will be applied to the next solution output.</source>
+        <translation>Ви змінили параметри кольору.
+Їх буде застосовано до наступного тексту розв&apos;язку.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="312"/>
+        <source>You have changed the application language.
+To get current solution output in the new language
+you need to re-run the solution process.</source>
+        <translation>Ви змінили мову додатку.
+Щоб отримати текст поточного розв&apos;язку
+на новій мові, потрібно виконати розв&apos;язок знову.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="487"/>
+        <source>%v of %1 parts found</source>
+        <translation>Знайдено %v з %1 переходів</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="510"/>
+        <source>Generating solution output...</source>
+        <translation>Генерація тексту розв&apos;язку...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="522"/>
+        <source>Generating step %v</source>
+        <translation>Генерація шагу %v</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="532"/>
         <source>Step #%1</source>
         <translation>Крок №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="460"/>
+        <location filename="../src/mainwindow.cpp" line="557"/>
+        <source>Generating footer</source>
+        <translation>Генерація закінчення</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="561"/>
         <source>Optimal path:</source>
         <translation>Оптимальний шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="462"/>
+        <location filename="../src/mainwindow.cpp" line="563"/>
         <source>Resulting path:</source>
         <translation>Знайдений шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="467"/>
+        <location filename="../src/mainwindow.cpp" line="568"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Вартість - &lt;b&gt;%1&lt;/b&gt; одиниць.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="470"/>
+        <location filename="../src/mainwindow.cpp" line="571"/>
         <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
-        <translation>&lt;b&gt;Увага!!!&lt;/b&gt;&lt;br&gt;Знайдений розв&apos;язок є рекордом, але може бути неоптимальним.&lt;br&gt;Для отримання оптимального розв&apos;зку, або перевірки поточного на оптимальність, потрібно продовжити ітерації.</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="680"/>
-        <location filename="../src/mainwindow.cpp" line="682"/>
+        <translation>&lt;b&gt;Увага!!!&lt;/b&gt;&lt;br&gt;Знайдений розв&apos;язок є рекордом, але може бути неоптимальним.&lt;br&gt;Для отримання оптимального розв&apos;язку, або перевірки поточного на оптимальність, потрібно продовжити ітерації.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="580"/>
+        <source>Cleaning up...</source>
+        <translation>Очищення...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="790"/>
+        <location filename="../src/mainwindow.cpp" line="792"/>
         <source>Unable to load the translation language.
 Falling back to autodetection.</source>
@@ -668,20 +781,30 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="754"/>
+        <location filename="../src/mainwindow.cpp" line="804"/>
+        <source>Would you like to save changes in the current task?</source>
+        <translation>Бажаете зберегти зміни у поточній задачі?</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="867"/>
         <source>Set application language to %1</source>
         <translation>Змінити мову додатку на %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="786"/>
+        <location filename="../src/mainwindow.cpp" line="888"/>
+        <source>Check for &amp;Updates...</source>
+        <translation>Перевірити &amp;оновлення...</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="908"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="276"/>
-        <source>Language will be autodetected on next application start.</source>
+        <location filename="../src/mainwindow.cpp" line="283"/>
+        <source>Language will be autodetected on the next application start.</source>
         <translation>Мову буде автоматично визначено при наступному запуску додатку.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="285"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -692,9 +815,8 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="151"/>
-        <location filename="../src/mainwindow.cpp" line="152"/>
-        <location filename="../src/mainwindow.cpp" line="168"/>
-        <location filename="../src/mainwindow.cpp" line="290"/>
-        <location filename="../src/mainwindow.h" line="107"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="179"/>
+        <location filename="../src/mainwindow.cpp" line="297"/>
+        <location filename="../src/mainwindow.h" line="113"/>
         <source>Untitled</source>
         <translation>Без імені</translation>
@@ -834,5 +956,5 @@
         <location filename="../ui/settingsdialog.ui" line="361"/>
         <source>Solution output settings</source>
-        <translation>Налаштування виводу розв&apos;язку</translation>
+        <translation>Налаштування тексту розв&apos;язку</translation>
     </message>
     <message>
